/*
KeePass for BlackBerry
Copyright 2007,2008 Fairview 5 Engineering, LLC <george.joseph@fairview5.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.fairview5.keepassbb;

import net.rim.blackberry.api.homescreen.HomeScreen;
import net.rim.device.api.synchronization.SyncManager;
import net.rim.device.api.system.*;
import net.rim.device.api.ui.Screen;
import net.rim.device.api.ui.UiApplication;

import com.fairview5.keepassbb.kpobjects.PwSyncManager;

public final class KeePassBB extends UiApplication implements Runnable,
		HolsterListener {
//	private static ResourceBundle _strings = ResourceBundle
//			.getBundle("com.fairview5.keepassbb.resources.language.KeePassBB");

	public static String version = ApplicationDescriptor
			.currentApplicationDescriptor().getVersion();
	public static String name = ApplicationDescriptor
			.currentApplicationDescriptor().getName();
	private static KeePassBB _this;
	private KeePassBBScreen s;
	// public static CodeSigningKey csk;

	static final long GUID_BASE = Utils.createGUID("com.fairview5.keepassbb");
	static final long GUID_LOG = Utils.createGUID("GUID_LOG");

	static int moduleId = ApplicationDescriptor.currentApplicationDescriptor()
			.getModuleHandle();

	public static void main(String[] argv) {
		EventLogger.register(GUID_LOG, "KeePassBB",
				EventLogger.VIEWER_STRING);

		if (argv != null && argv.length > 0 && argv[0].equalsIgnoreCase("init")) {
			ApplicationManager appman = ApplicationManager
					.getApplicationManager();
			long sleep = 2000;
			do {
				try {
					Thread.sleep(sleep);
				} catch (Exception e) {
				}
				sleep = 500;
			} while (appman.inStartup());
			Utils.logger(name + " "+version+" running on OS "+Utils.getOSSoftwareVersion());
			try {
				if (HomeScreen.getPreferredIconHeight() > 60) {
					HomeScreen.updateIcon(EncodedImage.getEncodedImageResource(
							"keepassbb80.png").getBitmap(), 0);
					HomeScreen.setRolloverIcon(EncodedImage
							.getEncodedImageResource("keepassbbro80.png")
							.getBitmap(), 0);
				} else {
					HomeScreen.updateIcon(EncodedImage.getEncodedImageResource(
							"keepassbb.png").getBitmap(), 0);
					HomeScreen.setRolloverIcon(EncodedImage
							.getEncodedImageResource("keepassbbro.png")
							.getBitmap(), 0);
				}
			} catch (Exception e) {
			}

			if (_this == null)
				_this = new KeePassBB(true);
			SyncManager.getInstance().enableSynchronization(
					new PwSyncManager(), true);
			SyncManager.getInstance().enableSynchronization(
					new Options.OptionsObject(), true);

			System.exit(0);
		}
		_this = new KeePassBB(false);
		new Thread(_this).start();
		_this.enterEventDispatcher();
	}

	public KeePassBB(boolean startup) {
		// csk = CodeSigningKey.get(this);
		if (startup)
			return;
		s = new KeePassBBScreen(Screen.DEFAULT_MENU);
		addHolsterListener(this);
		addGlobalEventListener(s);
		pushScreen(s);
		invokeLater(s);
	}

	public void inHolster() {
		if (Options.getBooleanOption(Options.OPTION_HOLSTER, false)) {
			synchronized (this.getAppEventLock()) {
				if (s.isDirty())
					s.save();
				System.exit(0);
			}
		}

	}

	public void outOfHolster() {
	}

	public void run() {
		while (true) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			int to = Options.getTimeout();
			if (to > 0 && DeviceInfo.getIdleTime() > to) {
				invokeAndWait(new Runnable(){
					public void run() {
						s.save();
						System.exit(0);
					}
				});
			}
		}
	}

	/**
	 * Get a string, given an id.
	 * 
	 * @param id
	 *            The id of the string.
	 * @return The String corresponding to the given id.
	 */
//	public static String getString(int id) {
//		return _strings.getString(id);
//	}

	/**
	 * Get a string array, given an id.
	 * 
	 * @param id
	 *            The id of the string array.
	 * @return The String[] corresponding to the given id.
	 */
//	public static String[] getStringArray(int id) {
//		return _strings.getStringArray(id);
//	}

}
