/*
KeePass for BlackBerry
Copyright 2007 Fairview 5 Engineering, LLC <george.joseph@fairview5.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.fairview5.keepassbb.kpobjects;

import java.util.Enumeration;


import net.rim.device.api.util.Arrays;
import net.rim.device.api.util.Comparator;

public final class SortedHashtable extends java.util.Hashtable implements Comparator {

  public SortedHashtable() {
    super();
  }

  public PwGroup get(int ix) {
    return((PwGroup)super.get(new Integer(ix)));
  }

  public PwEntry get(String ix) {
    return ((PwEntry) super.get(ix));
  }

  public boolean containsKey(int ix) {
    return (super.containsKey(new Integer(ix)));
  }

  public PwGroup remove(int ix) {
    return ((PwGroup)super.remove(new Integer(ix)));
  }

  public PwEntry remove(String ix) {
    return ((PwEntry) super.remove(ix));
  }

  public PwGroup put(int ix, PwGroup o) {
    return ((PwGroup)super.put(new Integer(ix), o));
  }

  public PwEntry put(String ix, PwEntry o) {
    return ((PwEntry) super.put(ix, o));
  }

  public void clear() {
    super.clear();
  }

  public PwGroup[] sortedGroupObjects() {

    PwGroup array[] = groupObjects();
    Arrays.sort(array, this);
    return (array);
  }

  public PwGroup[] groupObjects() {

    int len = size();
    PwGroup array[] = new PwGroup[len];
    if (len == 0) return (array);
    Enumeration eee = elements();
    int k = 0;
    while (eee.hasMoreElements()) {
      array[k++] = (PwGroup) eee.nextElement();
    }
    return (array);
  }

  public PwEntry[] sortedEntryObjects() {

    PwEntry array[] = entryObjects();
    Arrays.sort(array, this);
    return (array);
  }

  public PwEntry[] entryObjects() {

    int len = size();
    PwEntry array[] = new PwEntry[len];
    if (len == 0) return (array);
    Enumeration eee = elements();
    int k = 0;
    while (eee.hasMoreElements()) {
      array[k++] = (PwEntry) eee.nextElement();
    }

    return (array);
  }

  protected void rehash() {
    super.rehash();
  }

  public int compare(Object o1, Object o2) {
    return(o1.toString().compareTo(o2.toString()));
  }

}
