/*
KeePass for BlackBerry
Copyright 2007 Fairview 5 Engineering, LLC <george.joseph@fairview5.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.fairview5.keepassbb.ui;

import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.component.GaugeField;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.container.PopupScreen;
import net.rim.device.api.ui.container.VerticalFieldManager;

public final class ProgressDialog {

	public PopupScreen ps;
	public GaugeField gf;
	public LabelField lf;

	public ProgressDialog(final String legend) {
		synchronized (UiApplication.getEventLock()) {
				ps = new PopupScreen(new VerticalFieldManager());
				lf = new LabelField(legend);
				ps.add(lf);
				gf = new GaugeField(null, 0, 100, 0, GaugeField.PERCENT);
				ps.add(gf);
		}
	}

	public void show() {
		synchronized (UiApplication.getEventLock()) {
				UiApplication.getUiApplication().pushScreen(ps);
			}
	}

	public int doModal() {
		synchronized (UiApplication.getEventLock()) {
				UiApplication.getUiApplication().pushModalScreen(ps);
			}
		return 0;
	}

	public void setValue(final int value) {
		synchronized (UiApplication.getEventLock()) {
				gf.setValue(value);
			}
	}

	public void setValue(int value, int max) {
		gf.setValue((value * 100) / max);
	}

	public void setText(final String text) {
		synchronized (UiApplication.getEventLock()) {
				lf.setText(text);
			}
	}

	/*
	 * public boolean keyChar(char c, int status, int time) { if (c ==
	 * Characters.ESCAPE) { close(); return true; } return super.keyChar(c,
	 * status, time); }
	 */

	public void close() {
		synchronized (UiApplication.getEventLock()) {
				UiApplication.getUiApplication().popScreen(ps);
			}
	}

}