/*
KeePass for BlackBerry
Copyright 2007 Fairview 5 Engineering, LLC <george.joseph@fairview5.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.fairview5.keepassbb.ui;

import net.rim.device.api.ui.Font;
import net.rim.device.api.ui.Manager;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.container.HorizontalFieldManager;
import net.rim.device.api.ui.container.VerticalFieldManager;

public class TwoColumnListWidget extends VerticalFieldManager {
  long col1Style, col2Style;
  Font col1Font, col2Font;

  public TwoColumnListWidget() {
    this(0,0);
  }

  public TwoColumnListWidget(long c1, long c2) {
    super(Manager.VERTICAL_SCROLL | Manager.VERTICAL_SCROLLBAR);
    col1Style = c1;
    col2Style = c2;
  }

  public void addRow(String col1, String col2) {
    addRow(col1, col1Style, col2, col2Style);
  }

  public void addRow(String col1, int col2) {
    addRow(col1, col1Style, Integer.toString(col2), col2Style);
  }

  public void addRow(String col1, long col2) {
    addRow(col1, col1Style, Long.toString(col2), col2Style);
  }

  public void addRow(String col1, long col1Style, String col2, long col2Style) {
    HorizontalFieldManager hfm = new HorizontalFieldManager();
    LabelField c1 = new LabelField(col1, col1Style);
    LabelField c2 = new LabelField(col2, col2Style);
    if (col1Font != null) c1.setFont(col1Font);
    if (col2Font != null) c2.setFont(col2Font);
    hfm.add(c1);
    hfm.add(c2);
    super.add(hfm);
  }

  public void setFont(Font c1, Font c2) {
    col1Font = c1;
    col2Font = c2;
  }
}
